

use strict;
use utf8;


package slackget10::Plugin::Qt::LocalEditorWidget;
use Qt;
use Qt::isa qw(Qt::Widget);
use Qt::slots
    openButton_clicked => [],
    removeMessageButton_clicked => [],
    addMessageButton_clicked => [],
    loadLocalFile => ['const QString&'],
    createItem => ['QListView*', 'const QString&', 'const QString&'],
    saveButton_clicked => [],
    lv_messages_doubleClicked => ['QListViewItem*'],
    about_editor => [];
use Qt::signals
    localSaved => [];
use Qt::attributes qw(
    lv_messages
    commandButtonGroup
    addMessageButton
    removeMessageButton
    saveButton
    openButton
    closeButton
);

use lib '@@INSTALLDIR@@/lib';
use lib '/home/1024/progz/slack-get/V1.0/slack-get/lib/slackget10/lib';
use slackget10::Local;
use slackget10::File ;

our $image0;
our $image0_data =
["32 32 675 2",
"Qt c None",
"#3 c #000000",
"hG c #000004",
"hF c #000005",
"eZ c #010000",
"ir c #020100",
"e0 c #030100",
"iF c #030200",
"bB c #050100",
".C c #080300",
"e1 c #080400",
"bC c #080b97",
".N c #090300",
"iG c #090600",
"#d c #0a0400",
"eA c #0c0600",
"bD c #0e12a4",
"b4 c #0e139d",
"hg c #0f0300",
".q c #0f0500",
"bE c #1319a3",
"cu c #151ca4",
"bF c #171ea8",
".1 c #180900",
"ev c #1b0800",
"cV c #1e27aa",
"gT c #1f0000",
"is c #1f1100",
"cU c #220700",
"d6 c #231401",
"bG c #232179",
"b7 c #232fb7",
"eY c #240000",
"b6 c #252eb4",
"dj c #2531b4",
"ew c #271300",
"b8 c #2935b8",
"fo c #2c0000",
"al c #2c1000",
"dK c #2c3ab8",
"b5 c #2e35b7",
"di c #310e00",
"ct c #311100",
"cW c #313dba",
"cX c #3140bb",
"gu c #340000",
"dD c #361e02",
"iq c #362102",
"aP c #371600",
"b9 c #3744b6",
"iE c #382303",
"#t c #3b1500",
"cZ c #4052c3",
"bc c #441e03",
"f8 c #490000",
"cw c #4953c2",
"dM c #495bc7",
"cy c #4a58c4",
"c0 c #4b5dc8",
".B c #4d1e03",
"d5 c #4d2d00",
"dJ c #51426f",
"dL c #5362c8",
"dn c #5367cc",
"ec c #5369cd",
"dl c #5463c9",
"fL c #550000",
"b3 c #552701",
".p c #592300",
"dO c #596ed0",
"eb c #5a6ecd",
".f c #5c2500",
"ed c #5f77d2",
"aK c #602901",
"cY c #6270cd",
"hh c #630011",
"dI c #643205",
"hn c #65310c",
"ex c #68400f",
"dm c #6978d1",
"#c c #6d2902",
".b c #6d2c00",
".M c #6d300d",
"ip c #6e4f0f",
"ee c #6f89d9",
"hm c #72131e",
"iv c #764400",
"dP c #798ddb",
"ez c #7a4a10",
"ap c #7c3200",
"e# c #7c89b3",
"ak c #7f4702",
"#K c #813a01",
".j c #814300",
"aV c #828383",
"bH c #835b25",
".c c #853100",
"cv c #858bd6",
".k c #863300",
"dk c #868ed8",
"ea c #879bda",
"cx c #8b92d8",
".v c #8c3f08",
".e c #8f3800",
"bA c #8f4d17",
"ef c #90a9e4",
"am c #913801",
"it c #925b03",
"#L c #934000",
"ey c #936a2e",
"aq c #943e00",
"#2 c #945b03",
"eX c #950100",
"dN c #96a2e0",
"do c #96a5e2",
"cA c #9794c5",
"c. c #984c34",
"#4 c #994301",
"eB c #99668b",
"bd c #9a5900",
".0 c #9b4c1f",
"iD c #9b771c",
"e. c #9d6721",
"gn c #9f5a2b",
"aU c #9f9d94",
"an c #a04407",
"eW c #a11d00",
"hi c #a2000c",
".d c #a23c00",
"cz c #a2aae2",
"ao c #a34702",
"iu c #a36302",
"dC c #a36305",
"av c #a3a29f",
"hl c #a4141f",
".l c #a43b03",
"#s c #a55409",
"fH c #a6322f",
"fk c #a73000",
"aO c #a8540b",
"c1 c #aca5d0",
"fG c #ae6a47",
"fn c #af0100",
"e2 c #b1041d",
"a9 c #b16e0d",
"g3 c #b21207",
"io c #b2922a",
"d7 c #b38617",
"eu c #b47106",
"gG c #b52311",
"g2 c #b60d0b",
"g4 c #b6250c",
"gH c #b63013",
"fp c #b65d73",
"ar c #b66203",
"au c #b7b0a4",
"iw c #b87201",
"hk c #b90e16",
"fI c #b92927",
"gI c #ba3d17",
"aQ c #ba6a00",
"hj c #bb030c",
"gF c #bb1913",
"fh c #bc6c0b",
"gm c #bd5322",
"fM c #bdd0e3",
"g5 c #be3c13",
"#5 c #c16f0e",
"f3 c #c19650",
"gJ c #c24f1a",
".o c #c25313",
"aL c #c26a22",
"gl c #c31e0c",
"gS c #c32200",
"ia c #c38e16",
"gt c #c40100",
"f4 c #c43d32",
"cT c #c49b31",
"dp c #c63c5c",
"gM c #c66f29",
"dd c #c6861d",
"id c #c77f05",
"fl c #c80100",
"hp c #c86203",
".w c #c86834",
"i# c #c8991f",
"eE c #c8def4",
".m c #c95c23",
"bv c #ca730a",
"#r c #ca8135",
"f7 c #cb0100",
"ho c #cb7a00",
"cB c #cbbb85",
"hq c #cc610b",
"b. c #cc8442",
"dh c #ccaf52",
"eF c #cce2f5",
"fJ c #cd0100",
"f9 c #ce6877",
"dE c #ce991c",
"gE c #cf181c",
"g1 c #cf321e",
"cs c #cf9536",
"iC c #cfab2f",
"fK c #d00100",
"g6 c #d05d18",
"gU c #d1000e",
"hX c #d18603",
"c3 c #d35124",
"#q c #d3763f",
"gK c #d45e23",
"f0 c #d47c3c",
"go c #d48331",
"eD c #d4eaf7",
"dQ c #d53e54",
"#M c #d5840a",
".A c #d58d64",
"fj c #d58e0a",
"fi c #d6930e",
"aW c #d6c18d",
"#H c #d7824d",
"as c #d78f1e",
"ib c #d79613",
"#6 c #d7a04f",
"aw c #d7bc8e",
"h# c #d8a036",
"eG c #d8edf7",
"ds c #d9644b",
".i c #d97300",
"gv c #da010e",
".u c #da7900",
"hH c #da8200",
"hf c #db7f00",
"hE c #db8a01",
"aM c #db9354",
"bb c #db9d64",
"fm c #dc0100",
"bY c #dc7e29",
"f6 c #dd0800",
".n c #dd8050",
".G c #dd884a",
"aJ c #dd972c",
"eC c #dddbe1",
"gk c #de0a0a",
".F c #de7a0e",
".S c #de891d",
".5 c #de8b10",
"bw c #de8f42",
"#Z c #de9950",
"dU c #deb78d",
"#7 c #debd85",
"gs c #df0f00",
"g0 c #df2a2b",
"ah c #df9444",
"hr c #e07f13",
"ix c #e0950b",
"#g c #e0952f",
"i. c #e0b52f",
"#v c #e19303",
"#J c #e19b3f",
"dH c #e1ca77",
"gi c #e21516",
"fZ c #e2180c",
"aH c #e28733",
"dc c #e28a0b",
"#b c #e28c5a",
"eg c #e2c5cd",
"gj c #e31312",
"gL c #e32110",
"e3 c #e32c2f",
"f5 c #e33023",
"ek c #e36557",
".x c #e39167",
"eV c #e39d13",
"fC c #e3af4e",
"d8 c #e3c84c",
"b2 c #e5a755",
"fN c #e5e0e1",
"eH c #e5e5e8",
"g7 c #e68e1f",
"eN c #e69d4a",
"#w c #e6a03e",
".L c #e6a680",
"c4 c #e6aa0f",
"fc c #e6cb95",
"fq c #e72a2c",
"gN c #e7b136",
"gb c #e7eeee",
"g# c #e7f3f3",
"ga c #e7f7f7",
"e4 c #e87e7e",
"bi c #e8d98f",
"hI c #e99200",
"#f c #e99d03",
"e5 c #e99f9f",
".T c #e9a35f",
".6 c #e9a557",
"a8 c #e9bb35",
"iB c #e9c033",
"g. c #e9cdce",
"fR c #e9cece",
"fS c #e9f1f1",
"gr c #ea4201",
"co c #ea9846",
".4 c #ea9d00",
"#N c #eaa442",
"fO c #eaa9a9",
"be c #eaab03",
"at c #eab956",
"gc c #eadada",
"gh c #eb1719",
"gD c #eb2226",
"e6 c #eb9090",
".R c #eb9501",
"aN c #eba969",
"cC c #ebd91c",
"fP c #ec9494",
"fQ c #eca6a6",
"aR c #eca815",
"fg c #ecc038",
"d9 c #ecd473",
"a7 c #ed8c2e",
".E c #ed9000",
"d4 c #eda926",
"eI c #edafaf",
"cP c #edb047",
"ha c #edbb39",
"bI c #edbd04",
"dt c #edbf80",
"c# c #edc40b",
"fr c #ee0707",
"e7 c #ee6767",
"fB c #ee847d",
"el c #eea84f",
"iy c #eeab17",
"fT c #eeecec",
"c2 c #ef908f",
"h. c #efae3b",
"iz c #efb724",
"iA c #efc02e",
"in c #efd94c",
"bh c #f0da78",
"eh c #f0e5e5",
"fs c #f10909",
"eK c #f11515",
"eJ c #f15151",
"eM c #f16968",
"fw c #f18f8f",
"gd c #f19d9d",
".H c #f1b896",
"e8 c #f22e2e",
"hJ c #f29f09",
"g8 c #f2b72b",
"ei c #f2b7b7",
"fx c #f2dcdc",
"gq c #f37005",
"ft c #f40808",
"e9 c #f40e0e",
"eL c #f43737",
"fv c #f43d3d",
"ej c #f48181",
"ie c #f49700",
"#8 c #f4c67c",
"h9 c #f4d442",
"fu c #f51414",
"gZ c #f52223",
"f. c #f52d2d",
"gx c #f54040",
"f# c #f58282",
"bu c #f58c23",
"hY c #f59400",
"hs c #f5a41e",
"ic c #f5a70f",
".3 c #f5a800",
"fU c #f5b1b1",
"aj c #f5c757",
"g9 c #f5c83d",
"f1 c #f5e282",
"fy c #f5f2f2",
"gw c #f61515",
"gg c #f61a1c",
"cO c #f69109",
"#u c #f6af00",
"b# c #f6c594",
"gV c #f70001",
"dr c #f72525",
"gy c #f74e4e",
"gR c #f77e01",
".a c #f78100",
"gp c #f78e1f",
".r c #f79800",
"dS c #f7b0b0",
"#I c #f7d094",
"#1 c #f7db68",
"dT c #f7e6e6",
"bX c #f88405",
".y c #f8c1a4",
"#h c #f8c687",
"bz c #f8c68d",
"fF c #f8e250",
"gz c #f93e3e",
"ge c #f95353",
"cn c #f98a03",
"#Y c #f9a069",
".Q c #f9a900",
"#G c #f9a97a",
".Z c #f9c4a6",
"fa c #f9d7d7",
"gC c #fa2425",
"dR c #fa5c5c",
"ag c #faa161",
"hz c #facb3b",
"aI c #facd66",
".7 c #facd9f",
"dV c #face83",
"aT c #fad771",
"dF c #fae74d",
".g c #fb8500",
".2 c #fbad00",
"hK c #fbb015",
".U c #fbceaa",
"fz c #fbd0d0",
"fd c #fbd84d",
"bj c #fbdb5b",
"fD c #fbea5c",
"f2 c #fbf06b",
"gW c #fc0101",
"gY c #fc1617",
"gf c #fc1a1a",
"gA c #fc2727",
"fV c #fc5353",
".# c #fc8200",
".h c #fc8600",
".D c #fca100",
".P c #fcac00",
"#e c #fcb500",
"#p c #fcbb94",
"aS c #fccc50",
"#x c #fcce93",
"hy c #fcd241",
"de c #fce060",
"fY c #fd0909",
"gX c #fd090a",
"dq c #fd2121",
".t c #fd9200",
".s c #fd9600",
"bZ c #fdc17e",
"ax c #fdc56b",
"#O c #fdcc85",
"et c #fdce57",
"eR c #fdd042",
"eS c #fdd461",
".I c #fdd8c2",
".z c #fdddcc",
"im c #fded57",
"#0 c #fdee96",
"fb c #fdf4f4",
"fW c #fe1c1c",
"gB c #fe1f1f",
"fA c #fea1a1",
"if c #fea202",
"aG c #fea65a",
"dB c #feb42d",
"hU c #fec025",
"c5 c #fec039",
"ht c #fec22a",
"aX c #fec45c",
"hT c #feca30",
"bx c #fecf9c",
"cr c #fed176",
"eO c #fed45b",
"#i c #fed7a7",
"eU c #feda65",
".V c #feddc3",
"ba c #fedebb",
"ai c #fee082",
"cS c #fee46e",
"h8 c #fee953",
"cD c #fef526",
"dg c #fefb8e",
"fX c #ff0d0d",
"hZ c #ffa102",
"he c #ffa304",
"gQ c #ffa306",
"cN c #ffa403",
"db c #ffa611",
".O c #ffa700",
"hD c #ffa80a",
"h0 c #ffaa0d",
"hd c #ffab0e",
"cf c #ffab10",
"c8 c #ffac03",
"ig c #ffac0e",
"hW c #ffac0f",
"cI c #ffac1a",
"ce c #ffad0a",
"gP c #ffad0f",
"cG c #ffae05",
"cm c #ffaf00",
"c7 c #ffaf0c",
"cH c #ffb015",
"a6 c #ffb04e",
"dx c #ffb204",
"hC c #ffb215",
"dw c #ffb222",
"hc c #ffb417",
"cg c #ffb434",
"bW c #ffb510",
"bP c #ffb535",
"h1 c #ffb619",
"hV c #ffb61a",
"#X c #ffb682",
"dA c #ffb70d",
"gO c #ffb721",
"bQ c #ffb741",
"ih c #ffb81b",
"bn c #ffb84a",
"c6 c #ffb92b",
"bO c #ffb935",
"bt c #ffb93b",
"bm c #ffb946",
"cF c #ffba01",
"hB c #ffbb1f",
"af c #ffbb72",
"bl c #ffbc48",
"#F c #ffbc93",
"cd c #ffbd07",
"hL c #ffbd20",
"hb c #ffbd25",
"a0 c #ffbd5b",
"aZ c #ffbe58",
"cp c #ffbf73",
"h2 c #ffc024",
"aY c #ffc059",
"cJ c #ffc206",
"az c #ffc268",
"ii c #ffc327",
"hA c #ffc42a",
"bN c #ffc434",
"bk c #ffc449",
"ch c #ffc539",
"ay c #ffc569",
"#o c #ffc6a3",
"d2 c #ffc715",
"hM c #ffc72b",
"d3 c #ffc74a",
"aA c #ffc779",
"a. c #ffc97a",
"a# c #ffc97e",
"dY c #ffca3e",
"#9 c #ffca7c",
"h3 c #ffcb31",
"cq c #ffcb76",
"aF c #ffcc61",
"dv c #ffcc71",
"b0 c #ffcd8a",
"#E c #ffcd94",
"bf c #ffce1c",
"ij c #ffce34",
"#W c #ffce83",
"#a c #ffceb1",
"hu c #ffcf35",
"b1 c #ffcf8b",
"#P c #ffd08e",
"eo c #ffd164",
"bR c #ffd174",
"da c #ffd200",
"em c #ffd273",
"dX c #ffd27f",
"#A c #ffd29c",
"ae c #ffd373",
"#V c #ffd384",
"#U c #ffd386",
"#D c #ffd395",
"#C c #ffd396",
"#B c #ffd398",
"#n c #ffd3a4",
"## c #ffd3b4",
"hv c #ffd43c",
"hS c #ffd43d",
"ad c #ffd574",
"en c #ffd576",
"#Q c #ffd59a",
"c9 c #ffd600",
"h4 c #ffd63c",
"bo c #ffd685",
"#m c #ffd6a5",
"#l c #ffd6a7",
"#k c #ffd6a8",
"by c #ffd6a9",
"hx c #ffd744",
"#j c #ffd7a9",
"bg c #ffd83c",
"hN c #ffd83e",
"hw c #ffd844",
"eQ c #ffd85e",
"eP c #ffd861",
"aE c #ffd862",
"aD c #ffd863",
"cQ c #ffd872",
"ac c #ffd882",
"dW c #ffd892",
"ik c #ffd940",
"a5 c #ffd950",
"es c #ffd976",
"#T c #ffd99a",
"#z c #ffd9ab",
"#. c #ffd9b6",
"bJ c #ffda0d",
".8 c #ffdab7",
".9 c #ffdab8",
"hR c #ffdb44",
".Y c #ffdbc4",
"#y c #ffdcb1",
"a4 c #ffdd51",
"a3 c #ffdd55",
".X c #ffddc5",
"bK c #ffde15",
"hO c #ffde46",
"a1 c #ffde9d",
".W c #ffdec5",
"h5 c #ffdf47",
"cR c #ffdf72",
"du c #ffdfa6",
"hQ c #ffe04a",
"eT c #ffe07f",
"aa c #ffe0b5",
"bL c #ffe123",
"bM c #ffe12f",
"hP c #ffe14a",
"bs c #ffe23f",
"fe c #ffe254",
"er c #ffe271",
".K c #ffe2d3",
"ff c #ffe354",
"aC c #ffe392",
".J c #ffe3d3",
"br c #ffe440",
"bq c #ffe443",
"il c #ffe44c",
"#R c #ffe4bf",
"cc c #ffe803",
"h6 c #ffe851",
"ep c #ffe96d",
"a2 c #ffe992",
"#S c #ffe9ca",
"dz c #ffea00",
"bV c #ffea1d",
"aB c #ffeabd",
"cb c #ffeb0a",
"cE c #ffeb11",
"ca c #ffeb16",
"bp c #ffeb7a",
"bU c #ffec27",
"ab c #ffecc6",
"dy c #ffed01",
"bT c #ffed2d",
"bS c #ffed4e",
"h7 c #ffed57",
"cM c #fff000",
"fE c #fff061",
"cl c #fff201",
"d1 c #fff20a",
"ci c #fff20e",
"ck c #fff602",
"cj c #fff606",
"dZ c #fff732",
"eq c #fff781",
"dG c #fffa86",
"df c #fffb89",
"cK c #fffc00",
"d# c #fffd00",
"cL c #fffe00",
"d. c #ffff00",
"d0 c #ffff18",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.#.aQtQt.b.c.d.e.fQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.g.h.i.j.k.l.m.n.o.p.qQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.r.s.t.u.v.w.x.y.z.A.B.CQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.D.D.E.F.G.H.I.J.K.L.M.NQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQt.O.P.Q.R.S.T.U.V.W.X.Y.Z.0.1QtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt.2.3.4.5.6.7.8.9.8#.###a#b#c#dQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt#e#f#g#h#i#j#k#l#m#n#o#p#q#r#s#tQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt#u#v#w#x#y#z#A#B#C#D#E#F#G#H#I#J#KQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt#L#M#N#O#P#Q#R#S#T#U#V#W#X#Y#Z#0#1#2#3QtQtQtQt",
"QtQtQtQtQtQtQtQt#4#5#6#7#8#9a.a#aaabacadaeafagahaiajakalamanaoap",
"QtQtQtQtQtQtaqarasatauavawaxayazaAaBaCaDaEaFaGaHaIaJaKaLaMaNaOaP",
"QtQtQtQtQtQtaQaRaSaTaUaVaWaXaYaZa0a1a2a3a4a5a6a7a8a9b.b#babbbc#3",
"QtQtQtQtQtQtbdbebfbgbhbibjbkblbmbnbobpbqbrbsbtbubvbwbxbybzbAbBQt",
"QtQtbCbDbEbFbGbHbIbJbKbLbMbNbObPbQbRbSbTbUbVbWbXbYbZb0b1b2b3#3Qt",
"QtQtb4b5b6b7b8b9c.c#cacbcccdcecfcgchcicjckclcmcncocpcqcrcsctQtQt",
"QtQtcucvcwcxcyczcAcBcCcDcEcFcGcHcIcJcKcLcLcMcNcOcPcQcRcScTcUQtQt",
"QtQtcVcWcXcYcZc0c1c2c3c4c5c6c7c8.Oc9cLd.d#dadbdcdddedfdgdhdiQtQt",
"QtQtdjdkdldmdndodpdqdrdsdtdudvdwdxdyd.d.dzdAdBdCdDdEdFdGdHdIQtQt",
"QtdJdKdLdMdNdOdPdQdRdSdTdUdVdWdXdYdZd0d1d2d3d4d5#3d6d7d8d9e.QtQt",
"Qte#eaebecedeeefegeheiejekelemeneoepeqereseteuev#3#3ewexeyezeAQt",
"QteBeCeDeEeFeGeHeIeJeKeLeMeNeOePeQeReSeTeUeVeWeXeYeZQtQte0e1eZQt",
"Qte2e3e4e5e6e7e8e9f.f#fafbfcfdfefffgfhfifjfkflfmfnfoQtQtQtQtQtQt",
"QtfpfqfrfsftfufvfwfxfyfzfAfBfCfDfEfFfGfHfIfJfmfmfKfLQtQtQtQtQtQt",
"QtfMfNfOfPfQfRfSfTfUfVfWfXfYfZf0f1f2f3f4f5f6fmfmf7f8QtQtQtQtQtQt",
"Qtf9g.g#gagbgcgdgedqgfggghgigjgkglgmgngogpgqgrgsgtguQtQtQtQtQtQt",
"QtgvgwgxgygzgAgBgCgDgEgFgGgHgIgJgKgLgMgNgOgPgQgRgSgTQtQtQtQtQtQt",
"QtgUgVgWgXgYgZg0g1g2g3g4g5g6g7g8g9h.h#hahbhchdhehfhgQtQtQtQtQtQt",
"QthhhihjhkhlhmhnhohphqhrhshthuhvhwhxhyhzhAhBhChDhE#3QtQtQtQtQtQt",
"Qt#3#3hFhG#3#3hHhIhJhKhLhMhuhNhOhPhQhRhShThUhVhWhX#3QtQtQtQtQtQt",
"QtQtQtQtQtQtQthYhZh0h1h2h3h4h5h6h7h8h9i.i#iaibicid#3QtQtQtQtQtQt",
"QtQtQtQtQtQtQtieifigihiiijikiliminioipiqir#3isitiu#3QtQtQtQtQtQt",
"QtQtQtQtQtQtQtiviwixiyiziAiBiCiDiEiF#3QtQtQtQt#3iGQtQtQtQtQtQtQt"];

our $image1;
our $image1_data =
["22 22 160 2",
"Qt c None",
"aB c #020207",
"aq c #040d17",
".1 c #050e1a",
"aC c #05111e",
"#w c #051320",
"#Y c #051421",
"aD c #06121f",
"#K c #061221",
".0 c #07101c",
"aA c #081421",
".2 c #0b1420",
".Z c #0c1521",
".N c #0c1825",
"#J c #0e96be",
"#f c #0f4364",
"#u c #0f96be",
"#X c #1097be",
".g c #121e2a",
"ap c #124566",
"#v c #126a92",
"#t c #1398bf",
"#s c #1498bf",
".Y c #151e2a",
"as c #161f2a",
"#e c #166c94",
"#I c #1699c0",
"ab c #18212d",
"az c #182837",
"at c #19222d",
"aa c #199ac1",
"ar c #1a232d",
"#d c #1b6f96",
"aw c #1b9bc1",
"ax c #1d7197",
"#c c #1e7197",
"aj c #1f9cc1",
"#g c #202833",
"ay c #22303d",
"ao c #27779b",
"av c #27a0c4",
".E c #28323d",
"a# c #2aa1c5",
"#W c #2ca2c5",
"au c #2d7a9d",
"#r c #2da2c5",
"ak c #2ea4c6",
"an c #347fa1",
"ae c #3980a3",
".o c #3a444f",
"al c #3a657f",
"af c #3a82a3",
"ai c #3da9c9",
"#H c #3daaca",
".f c #3e4751",
".M c #3e85a4",
"a. c #3eabca",
".w c #3f4853",
"am c #3f86a6",
"#7 c #41aacb",
"#Z c #464e55",
".# c #465059",
".O c #474d56",
"#b c #486f89",
"ac c #496f88",
"ad c #4d8caa",
".X c #4e8fac",
"#8 c #51b3cf",
"#9 c #52b4d0",
"ah c #56b3ce",
"ag c #587c91",
"#V c #58b5d1",
".D c #5b97b3",
"#q c #60b8d2",
"#6 c #61b9d1",
".h c #626971",
".e c #676e75",
"#G c #6abdd5",
".L c #6bbcd4",
"#T c #6bbdd6",
"#F c #6cbed5",
".p c #6d747c",
"#2 c #6dbcd3",
"#o c #6ebdd4",
"#U c #6ebfd7",
"#L c #70767b",
"#3 c #70bfd5",
"#E c #71bed5",
"#a c #72bfd5",
".3 c #737880",
"#h c #757b83",
"#S c #75c0d7",
".c c #767d83",
"#p c #76c0d5",
".b c #777f84",
"#n c #78c1d7",
"#x c #797e83",
".W c #79c2d7",
".a c #7c8086",
"#D c #7cc2d6",
"#. c #7cc3d6",
".x c #7d8288",
".n c #7f9aaa",
".C c #7fc2d8",
".d c #80878e",
".G c #81858b",
"#5 c #83c7db",
"## c #84c7d9",
".v c #86b1c6",
"#R c #88c7db",
"#P c #89cadd",
".U c #8ac9db",
".V c #8acadb",
".P c #8d9296",
"#4 c #8dccde",
"#C c #91ccdd",
".Q c #93999e",
".K c #94cbdc",
"#1 c #94cddf",
"#0 c #95bccb",
"#Q c #99d1e1",
".9 c #9acfdd",
"#B c #9acfdf",
"#m c #9dd0dd",
"#O c #a3d4e2",
".q c #a5c2d2",
".m c #a5c5d5",
".T c #a9d7e4",
".k c #acc9d6",
".J c #acd6e4",
".u c #acd7e5",
".R c #aeafb5",
".B c #afd8e6",
".j c #b1ccd4",
".8 c #b3c2cb",
".i c #b3c3cb",
".y c #b3ced9",
".H c #b5d0db",
".4 c #b6c4ce",
".A c #b6dbe6",
".S c #b8d0db",
"#M c #b9d2dd",
"#l c #b9dce6",
".r c #badee3",
"#A c #badee7",
".l c #bcd5de",
".I c #bfdfe7",
".7 c #c3d7e2",
".s c #c3e0e7",
"#N c #c3e1eb",
"#y c #c7d9e2",
".z c #c7e3eb",
".t c #c8e4e9",
".6 c #cadbe2",
"#i c #cbdae2",
".5 c #ccdce3",
"#k c #cde5ed",
"#z c #d4e9f1",
"#j c #d8ebf0",
".F c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.#.a.b.c.d.e.f.gQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.h.i.j.k.l.m.n.oQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.p.q.r.s.t.u.v.wQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.x.y.z.A.B.C.D.EQtQtQtQtQtQtQt",
"QtQt.F.F.F.F.F.G.H.I.J.K.L.M.NQtQtQtQtQtQtQt",
"QtQt.F.O.a.P.Q.R.S.T.U.V.W.X.Y.Z.0.1.2QtQtQt",
"QtQt.F.3.4.5.6.7.8.9#.###a#b#c#d#e#f#gQtQtQt",
"QtQt.F#h#i#j#k#l#m#n#o#p#q#r#s#t#u#v#wQtQtQt",
"QtQt.F#x#y#z#A#B#C#D#E#F#G#H#I#J#J#v#KQtQtQt",
"QtQt.F#L#M#N#O#P#Q#R#S#T#U#V#W#X#J#v#YQtQtQt",
"QtQtQt#Z#0#1#2#3#4#5#6#7#8#9a.a#aa#v#wQtQtQt",
"QtQtQtabacadaeafagahaiajakalamanaoapaqQtQtQt",
"QtQtQt.2ararasatauavaw#J#XaxayayazaAaBQtQtQt",
"QtQtQtQtQtQtQtaC#v#J#J#J#J#vaDQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtaC#v#J#J#J#J#vaCQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtaC#v#J#J#J#J#vaCQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtaC#f#v#v#v#v#faCQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtaCaCaCaCaCaCaCaCQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"];

our $image2;
our $image2_data =
["22 22 108 2",
"Qt c None",
"#P c #020207",
"#I c #040d17",
"#J c #050e1a",
"#K c #05111d",
"#O c #05111e",
".V c #051320",
"#n c #051421",
"#L c #051423",
"#. c #061221",
"#M c #061625",
"#N c #061727",
"#B c #07101c",
".p c #0b1420",
".n c #0c1521",
"#A c #0e96be",
"#H c #0f4364",
".o c #101924",
"#m c #1097be",
".U c #126a92",
"#z c #1297bf",
"#G c #136b92",
".m c #141d28",
"#F c #156c93",
".9 c #1599c0",
".T c #1699c0",
"#C c #174969",
"#E c #186e94",
"#y c #199ac0",
"#o c #1a242e",
"#D c #1c7096",
"#l c #1e9dc2",
".F c #202833",
"#x c #209dc2",
"#v c #219dc2",
"#w c #229dc2",
"#u c #239dc1",
"#t c #239ec2",
".l c #2b323d",
"#s c #2da2c5",
".a c #323a44",
".8 c #32a5c6",
".D c #337fa1",
".S c #35a6c8",
"#p c #3a83a4",
"#k c #3aa8ca",
"## c #3c4650",
"#r c #3fa9c8",
"#q c #44a8c0",
".C c #468aaa",
".e c #485057",
".k c #495059",
".f c #4c525c",
".E c #51718a",
".7 c #56b4d0",
"#j c #5ab6d2",
".R c #5cb7d1",
".g c #5d646b",
".j c #60666f",
".b c #646a72",
".q c #656c73",
".B c #659eb6",
".i c #676c74",
".d c #686e74",
".W c #6a7177",
"#e c #6abbd3",
".h c #6b7077",
".c c #6d7279",
"#i c #70c0d7",
"#f c #73bfd7",
".6 c #74c1d9",
"#a c #76a8be",
"#d c #76c0d7",
".Q c #78c3d9",
"#b c #79c3d9",
"#h c #7bc4d8",
".A c #7fadc4",
"#g c #80c6da",
".G c #868a8e",
"#c c #87c9db",
".5 c #8bcbdf",
".P c #90cedf",
".z c #9bbfcf",
".O c #9bd2e2",
".M c #9cd2e1",
".N c #9dd3e1",
".4 c #9dd3e2",
".2 c #a5d6e3",
".1 c #a6d5e3",
".3 c #a7d6e5",
".0 c #aad7e4",
".L c #abd8e3",
".y c #adcad9",
".Y c #b8dce8",
".K c #b8dfe7",
".Z c #badfe9",
".w c #bdd4df",
".x c #bed3de",
".v c #c7dae2",
".J c #cae4ed",
".I c #cfe7ef",
".u c #d1e0e8",
".X c #d3e1e8",
".t c #dee8ed",
".s c #dfe9ee",
".r c #e0e5ea",
".H c #e9eff2",
".# c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQt.#.#.#.#.#.#QtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQt.#.a.b.c.d.e.f.g.h.i.j.k.l.m.n.o.pQtQtQt",
"QtQt.#.q.r.s.t.u.v.w.x.y.z.A.B.C.D.E.FQtQtQt",
"QtQt.#.G.H.I.J.K.L.M.N.O.P.Q.R.S.T.U.VQtQtQt",
"QtQt.#.W.X.Y.Z.0.1.2.3.4.5.6.7.8.9.U#.QtQtQt",
"QtQt.####a#b#c#d#e#f#g#h#i#j#k#l#m.U#nQtQtQt",
"QtQtQt#o#p#q#r#s#t#u#v#w#x#y#z#A#A.U.VQtQtQt",
"QtQtQt#B#C#D#E#F#F#G.U.U.U.U.U.U.U#H#IQtQtQt",
"QtQtQt#J#J#J#J#J#J#J#J#K#L#M#M#M#N#O#PQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"];

our $image3;
our $image3_data =
["22 22 321 2",
"Qt c None",
"aq c #000030",
"d. c #04043e",
"cS c #06063e",
"c9 c #06073d",
"cA c #080940",
"cj c #0a0b42",
"b3 c #0b0b43",
"bL c #0d0d45",
"c8 c #0d0e43",
"bt c #0f0f47",
"bb c #111249",
"cR c #121841",
"aX c #14154c",
"aH c #191a52",
"cz c #19224c",
"ap c #1c1d54",
"ci c #1e264f",
"#9 c #1f2057",
"b2 c #202953",
"#R c #22235a",
"cQ c #252d54",
"#z c #26275d",
"bK c #262d58",
"#j c #2a2b60",
"bs c #2b335d",
"cy c #2e3a62",
".6 c #303065",
"ba c #313963",
"ch c #313c64",
".R c #323268",
"cV c #323365",
"c7 c #333363",
"b1 c #343f68",
"c6 c #353564",
"c5 c #373766",
"cU c #37386a",
"c4 c #393967",
"aW c #3a436c",
"bJ c #3a456d",
"c3 c #3b3b69",
".V c #3b5585",
"c2 c #3d3d6b",
"c1 c #3f3f6c",
"br c #3f4b72",
"c0 c #41416e",
"cT c #424373",
"cZ c #43436f",
"aG c #444d75",
"cY c #464671",
"cX c #484873",
"b# c #48547a",
"cW c #4a4a74",
"ao c #4b547b",
"#. c #4f6691",
"aF c #515f85",
"aV c #535f84",
"#8 c #545d82",
"an c #566489",
"cB c #575b85",
".W c #586d97",
"#Q c #5c6489",
"am c #5c6a8f",
"ck c #60658d",
"#7 c #606e92",
".C c #654351",
"#y c #656e91",
"aE c #687495",
"b4 c #696e94",
"cC c #6f7899",
".I c #7082a6",
"bM c #72779b",
"#P c #727e9f",
"#i c #747d9e",
"aD c #757790",
"cD c #757c9b",
"#6 c #767992",
".H c #7688aa",
"bu c #797ea0",
"cl c #7b88a7",
".X c #7e8fae",
"bc c #7f83a4",
"## c #8090b0",
"cf c #8181a2",
"cP c #82829e",
"#x c #8289a2",
".5 c #838ba8",
"al c #846968",
"bZ c #8484a5",
"cm c #848eab",
"b5 c #8491ad",
"cg c #8585a4",
"cw c #8585a5",
"ce c #8686a5",
"aY c #868aa9",
"cO c #8787a1",
".J c #8797b4",
"cv c #8888a7",
"bY c #8888a8",
".Q c #89727c",
"b0 c #8989a7",
"cd c #8a8aa9",
"cN c #8b8ba4",
"cx c #8b8ba9",
"bp c #8b8bab",
"aI c #8b8fad",
"cM c #8c8ca4",
"bX c #8c8cac",
"b6 c #8c96b1",
"cu c #8e8eac",
"bN c #8e9cb6",
"cc c #8f8fad",
"bH c #9090ad",
"cL c #9292a9",
"bI c #9292ad",
"ct c #9292af",
"ar c #9296b2",
"bq c #9393af",
"bo c #9493b3",
"bG c #9494b1",
"bO c #949fb8",
"#h c #97878a",
"cK c #9797ad",
"cb c #988593",
"a. c #989bb5",
".v c #9999b3",
"af c #99a3b6",
"ae c #9aa8c1",
"bv c #9ba8c0",
"#n c #9ba8c1",
"bF c #9c8e9f",
"cJ c #9c9cb1",
"cs c #9d8d9b",
".u c #9d9db6",
"bW c #9e8892",
"#S c #9ea1ba",
"bw c #9fa9c0",
"ad c #9facc4",
"#a c #a1aec5",
".r c #a2a3bb",
"cI c #a399a6",
".t c #a3a3ba",
"bd c #a3afc6",
"#A c #a4a7be",
"ac c #a4b0c7",
".q c #a5a7be",
"aw c #a5b0c7",
".s c #a7a7be",
"#Z c #a8b4c9",
"ab c #a9b5ca",
"cr c #aa7561",
"#k c #aaadc3",
"cH c #aba3af",
"be c #abb5ca",
".p c #acadc2",
"av c #acb7cb",
"#Y c #acb7cc",
"b. c #aeaec2",
"aJ c #aeb9cc",
"aa c #aeb9cd",
".7 c #b0b3c7",
"au c #b0bace",
"cG c #b1b1c1",
"#X c #b1bbce",
"c# c #b29080",
"cq c #b39899",
"ax c #b3a892",
"bn c #b48777",
"at c #b4bed0",
"as c #b4bed1",
"c. c #b59e9d",
"#W c #b5bfd1",
"cF c #b6b6c5",
"cp c #b6b6cc",
".n c #b6b7cb",
".S c #b6b8cb",
"#U c #b7c1d3",
"b9 c #b8b8ce",
".l c #b8b9cb",
"a9 c #b9b9cb",
"#o c #b9c2d4",
"#V c #b9c3d4",
"bR c #babad1",
".m c #babccd",
"a# c #bac3d4",
".e c #bb4400",
".o c #bbbbcd",
"co c #bbbbd0",
"ca c #bc9383",
"cE c #bcbcc9",
"aU c #bcbcce",
"b8 c #bcbcd2",
".B c #bd6d39",
".4 c #bd7e53",
"#0 c #bdb297",
".D c #bdbfd0",
"bQ c #bfbfd5",
"bh c #bfbfd7",
"#T c #c0c8d8",
"bS c #c1aaa3",
"a8 c #c1aeb1",
"bi c #c2bbc6",
"aT c #c2c1d1",
"#5 c #c4804a",
".w c #c4a248",
"bg c #c4c4db",
"#B c #c5cddb",
"#O c #c7a696",
"cn c #c7c7d7",
"#C c #c8d0dd",
"bz c #c9c9da",
"b7 c #cbcbdb",
"#l c #cbd2df",
"bA c #cdbdb8",
"aS c #cea994",
"by c #cecedf",
"#p c #cfd5e1",
".k c #d07843",
"bP c #d0d0df",
".d c #d17b47",
".8 c #d1d7e3",
"#m c #d2d8e3",
"aC c #d38c50",
"bV c #d5ab93",
".9 c #d6dce6",
"ag c #d7bb5f",
".T c #d7dce6",
"bf c #dadae8",
"bE c #dba172",
".U c #dbe0e8",
"bx c #dcdce7",
".c c #de9b6e",
"a7 c #e1a46c",
".E c #e1e4ec",
".F c #e3e7ee",
".P c #e68830",
"a2 c #e6e0d8",
"a1 c #e9e9ef",
"#w c #eaa569",
"#I c #eaeae9",
"#H c #eaedf2",
"bT c #ebcfb3",
"aM c #ebe8e8",
"#G c #ebeef2",
".# c #ec9100",
"#F c #eceff3",
".b c #edbb7b",
"#E c #edf0f4",
"#g c #ee8a2b",
".f c #ee9b00",
"#D c #eef1f5",
"#N c #ef9b44",
".j c #efc7a8",
".a c #f0ab05",
"a0 c #f1f1f4",
"ay c #f2da5e",
"aN c #f3d98c",
"aR c #f4b56b",
"aL c #f4f4f7",
"ak c #f5a953",
"bB c #f7d3a6",
".A c #f8a648",
".L c #f8ce1e",
"bU c #f8e4ce",
".g c #f9d004",
"bj c #f9d583",
"#J c #f9d658",
"#c c #fad849",
".Z c #fad993",
"a3 c #fada6b",
"#1 c #fbde3d",
"#r c #fbe3a4",
"aZ c #fbfbfc",
"#v c #fca638",
"bm c #fcd18b",
"#s c #fcdf28",
"bD c #fce3b4",
"aK c #fcfcfd",
".3 c #fd9e25",
".x c #fddf01",
"#b c #fdf4e4",
".0 c #fee205",
".i c #fee8c3",
"aO c #feec73",
".K c #fefaf3",
".O c #ffab18",
"#f c #ffb225",
".2 c #ffba13",
".z c #ffba1a",
"#4 c #ffba4f",
".N c #ffbf04",
"#M c #ffbf3e",
"#u c #ffc62a",
"aB c #ffc669",
".y c #ffc704",
"#e c #ffc81c",
"aj c #ffca56",
"#L c #ffcd37",
"#3 c #ffcd44",
".1 c #ffcf0d",
"#t c #ffd527",
"a6 c #ffd580",
"aQ c #ffd76e",
"ai c #ffd852",
"aA c #ffd85d",
".M c #ffdd03",
"#2 c #ffde45",
"aP c #ffdf6d",
"a5 c #ffdf77",
"bl c #ffe089",
"#d c #ffe115",
".h c #ffe45f",
"az c #ffe663",
"#K c #ffe734",
"bk c #ffe896",
"ah c #ffec57",
"a4 c #ffed83",
"bC c #ffeecd",
"#q c #fffefe",
".Y c #fffffe",
".G c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQt.#.a.b.c.d.eQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt.f.g.h.i.j.k.eQtQtQtQt",
".l.m.n.o.p.q.r.s.t.u.v.w.x.y.z.A.B.CQtQtQtQt",
".D.E.F.G.H.I.J.G.G.G.K.L.M.N.O.P.Q.RQtQtQtQt",
".S.T.U.G.V.W.X.G.G.Y.Z.0.1.2.3.4.5.6QtQtQtQt",
".7.8.9.G#.###a.G.G#b#c#d#e#f#g#h#i#jQtQtQtQt",
"#k#l#m.G#n#o#p.G#q#r#s#t#u#v#w#x#y#zQtQtQtQt",
"#A#B#C#D#E#F#G#H#I#J#K#L#M#N#O#P#Q#RQtQtQtQt",
"#S#T#U#V#W#X#Y#Z#0#1#2#3#4#5#6#7#8#9QtQtQtQt",
"a.a#aaabacadaeafagahaiajakalamanaoapQtQtaqaq",
"aras#YatauavawaxayazaAaBaCaDaEaFaGaHaqaqaqaq",
"aIaJ#V.GaKaLaMaNaOaPaQaRaSaTaUaVaWaXaqaqaqaq",
"aY#Z#WaZa0a1a2a3a4a5a6a7a8a9b.b#babbaqaqaqaq",
"bcbdbebfbgbhbibjbkblbmbnbobpbqbrbsbtaqaqaqaq",
"bubvbwbxbybzbAbBbCbDbEbFbGbHbIbJbKbLaqaqaqaq",
"bMbNbObPbQbRbSbTbUbVbWbXbYbZb0b1b2b3aqaqaqQt",
"b4b5b6b7b8b9c.c#cacbcccdcecfcgchcicjQtQtQtQt",
"ckclcmcncocpcqcrcsctcucvcecwcxcyczcAQtQtQtQt",
"cBcCcDcEcFcGcHcIcJcKcLcMcNcOcPcQcRcSQtQtQtQt",
"cTcUcVcWcXcYcZc0c1c2c3c4c5c6c7c8c9d.QtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"];

our $image4;
our $image4_data =
["22 22 284 2",
"Qt c None",
"aD c #0015c8",
"aj c #0017c9",
"aE c #0019c6",
"cz c #001bb5",
"b4 c #001cb5",
"aX c #001cc0",
"bP c #001eb6",
"by c #001fb7",
"bd c #001fbc",
"ai c #001fc8",
"be c #0020b8",
"aC c #0022ca",
"aY c #0023b8",
"aF c #0024ba",
"ak c #0024bd",
"cg c #0025b7",
"aW c #0025cf",
"al c #0026bb",
"#2 c #0026c0",
"#3 c #0027bc",
"#K c #0028bd",
"#J c #0028cc",
"#q c #0029bd",
"#e c #002cbe",
"#d c #002dbf",
".U c #002ec0",
"#c c #002fc1",
"b5 c #0039c7",
"ch c #003bc8",
"aB c #0128cb",
"aV c #0133d6",
"aU c #0133d7",
"bc c #033bde",
"bb c #0341e4",
"ba c #0443e4",
"aT c #063ddd",
"cy c #0731b6",
"#1 c #0732d0",
".v c #084bd0",
"#5 c #0d52d3",
"ah c #1039d3",
"aA c #1142dc",
"cx c #123bb7",
"bQ c #1353d2",
"cw c #143dba",
"cv c #1842bd",
"a1 c #195ad4",
"cu c #1a46bf",
"az c #1a52e7",
"bR c #1a58d2",
"aS c #1c5bee",
"#b c #1d46c0",
"#I c #1d6bf0",
"ct c #1e4bc2",
"bz c #1e5dd6",
"bx c #1f3cc6",
".p c #1f61d7",
"#j c #2057d0",
"cs c #224fc5",
"#C c #2258d1",
"bf c #2260d7",
"b# c #2261ee",
"b3 c #244ac1",
"ay c #2462f0",
"cr c #2553c9",
"aZ c #2562d7",
"ci c #2760d4",
"aG c #2765d9",
"cq c #2857cb",
"ag c #2964e9",
"am c #2966da",
"cp c #2c5bcf",
"#4 c #2d6ada",
"co c #2f60d1",
"#L c #306cdb",
"cn c #3263d3",
"aR c #3270f3",
"#r c #336edc",
"af c #3377f5",
"bw c #344fcb",
"cm c #3465d5",
"cl c #3467d6",
"ck c #3669d6",
"#f c #3670dc",
"cj c #376bd7",
".5 c #3973dc",
"ax c #3976f4",
"#0 c #397df6",
"bA c #3a77df",
".V c #3c75dd",
"bv c #3d59d1",
".F c #3d76de",
"bu c #4160d7",
"b. c #427ff6",
".4 c #4358be",
"bt c #436ae0",
".T c #455abf",
"bs c #4571e7",
"#G c #4594ff",
"aH c #4684e4",
"#Z c #4696ff",
"#t c #4771d2",
"ae c #478cfc",
"#F c #4796ff",
"aQ c #4884f6",
"ao c #4a7fe1",
"#Y c #4c99ff",
"#H c #4c9cff",
"br c #4f78e7",
"aw c #508af8",
"#M c #518fe9",
"bh c #5788e3",
"a9 c #5792fa",
"ad c #599cff",
".E c #5b66bf",
".u c #5c94eb",
"aP c #5f98fb",
"bO c #6075ca",
"#a c #6184dc",
".t c #6298eb",
".o c #636dc2",
"#k c #6493ea",
"bq c #658ded",
"av c #659efb",
"## c #6689de",
"#. c #668adf",
"#N c #6796e7",
".s c #679ced",
".h c #6a74c3",
".D c #6a74c6",
"b6 c #6a93e6",
"a8 c #6ca6fd",
".c c #6d76c5",
"#B c #6d90e3",
".r c #6d9fed",
"ac c #6dabff",
"#A c #6f94e4",
"#p c #6f9cf1",
".q c #6fa1ed",
"#z c #7397e6",
"aO c #73abfe",
"#D c #74a0ef",
"#o c #74a0f1",
".a c #757dc8",
"#y c #759ae7",
".# c #7781c9",
".M c #7788d0",
"#x c #779ee8",
".d c #7882c9",
"a6 c #78b1fa",
"a7 c #79b1fd",
".b c #7a83ca",
"#w c #7aa1ea",
"bg c #7ab1f2",
"#E c #7ab5ff",
".i c #7d85ca",
"#v c #7da3ed",
"au c #7db3ff",
"bp c #7ea4f5",
"#u c #7ea6ed",
".w c #7f88cb",
"#n c #81abf4",
"ab c #81bbff",
".3 c #828bd1",
"#X c #82bbff",
"#m c #84aef6",
"#V c #85b2f6",
"an c #85bbf6",
"#l c #86b0f6",
"aN c #88bdff",
".e c #8990d1",
"#W c #89b6fb",
"aM c #8abefc",
"#U c #8dbaf6",
"bo c #8fb5f9",
".7 c #939dd6",
"bn c #93b8f8",
"a5 c #94d2ff",
".L c #96c1f6",
".n c #979eda",
".X c #97aee4",
"#T c #97bff8",
"aI c #98baf3",
"aa c #99ccff",
"aL c #9cd2ff",
".x c #9fa4db",
"#g c #a0b8e8",
"#S c #a1c7f9",
"at c #a1d2ff",
"bm c #a2cafe",
"#s c #a2d3fe",
".Y c #a3aadc",
"cf c #a4a7cb",
"a4 c #a6ddff",
"#R c #aacdf9",
"ce c #abaccf",
"#O c #acc1f1",
".6 c #aed0f6",
"cd c #b0b1d1",
"bB c #b0c8f6",
".K c #b1e5ff",
"bN c #b2b2d9",
"ar c #b2d0f1",
"bl c #b2daff",
"#Q c #b3d3fa",
"b2 c #b4b4db",
".W c #b4e4ff",
"bM c #b8b8dc",
"cc c #b8bad6",
"a# c #b8e5ff",
".J c #b8eaff",
"b1 c #bcbcde",
".j c #bdc0e8",
"#P c #bdd5fb",
"bL c #bebee0",
"a0 c #beeaff",
".I c #beeeff",
"bk c #bfe5ff",
"a3 c #bfeaff",
"cb c #c0c1dd",
"b0 c #c1c1e1",
".S c #c2c8ed",
"aK c #c2efff",
"bK c #c6c6e4",
".H c #c6f1ff",
"as c #c7eeff",
"bZ c #c8c8e6",
".N c #c9cced",
"ca c #cacbe3",
"bJ c #cbcbe7",
"bj c #cbeeff",
"a. c #ccf2ff",
".G c #ccf5ff",
"#h c #cdd2ef",
"bY c #cfcfe9",
"bI c #d3d3eb",
"c# c #d3d4e8",
"#7 c #d4e0fa",
"bX c #d5d5ed",
".9 c #d5daf6",
".f c #d7daf4",
"bi c #d7f2ff",
"bH c #d9d9ef",
"aq c #d9f6ff",
"#i c #dadff9",
"bW c #dcdcf1",
"c. c #dcddef",
".g c #dcdff6",
"bG c #dfdff2",
".8 c #dfe1f6",
"#9 c #e1ffff",
"bV c #e3e3f4",
".2 c #e3e3f8",
"#8 c #e3f3ff",
".y c #e4e6fa",
".R c #e5e5f9",
"aJ c #e5fcff",
"b9 c #e6e6f4",
"bF c #e6e6f6",
".B c #e6e6fa",
"#6 c #e7f6ff",
"bU c #e8e8f8",
".l c #eaeafb",
"bE c #ededfa",
".C c #eeeefd",
".m c #efeffd",
".A c #efeffe",
"b8 c #eff0fa",
"a2 c #effeff",
"bT c #f0f0fb",
"ap c #f0feff",
"bD c #f2f2fd",
".Q c #f2f2ff",
".z c #f3f3ff",
".k c #f5f5ff",
".Z c #f5f6ff",
"bS c #f6f6ff",
".P c #f8f8ff",
"b7 c #f9f9ff",
"bC c #fafaff",
".1 c #fcfcff",
".O c #fdfdff",
".0 c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQt.#.a.b.cQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQt.d.e.f.g.hQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.i.b.j.k.l.m.n.oQtQtQtQtQt",
".p.q.r.s.t.u.vQt.w.x.y.z.A.l.B.C.D.EQtQtQtQt",
".F.G.H.I.J.K.L.M.N.O.P.Q.A.l.B.R.S.T.UQtQtQt",
".V.G.H.I.W.X.Y.Z.0.1.P.Q.A.l.B.2.C.3.4QtQtQt",
".5.G.H.6.7.8.0.0.0.1.P.Q.A.l.9#.###a#b#c#d#e",
"#f.G.H#g#h.0.0.0.0.1.P.Q.A#i#j#k#l#m#n#o#p#q",
"#r.G.H#s#t#u#v#w#x#y#z#A#B#C#D#E#F#G#H#I#J#K",
"#L.G.H#M#N#O#P#Q#R#S#T#U#V#W#X#Y#G#Z#0#1#2#3",
"#4.G.H#5#6#7#8#9a.a#aaabacadaeafagahaiajakal",
"am.GanaoapaqarasatauavawaxayazaAaBaCaDaEaFQt",
"aG.GaHaIaJaKaLaMaNaOaPaQaRaSaTaUaVaWaDaXaYQt",
"aZa0a1a2a3a4a5a6a7a8a9b.b#babbbcaVaWaDbdbeQt",
"bfbgbhbibjbkblbmbnbobpbqbrbsbtbubvbwbxbyQtQt",
"bzbAbB.0.0.0bCbDbEbFbGbHbIbJbKbLbMbNbObPQtQt",
"bQbR.0.0.0.0.1bSbTbUbVbWbXbYbZb0b1b2b3b4QtQt",
"b5b6.0.0.0.0.0b7b8b9c.c#cacbcccdcecfcgQtQtQt",
"chcicjckclcmcncocpcqcrcsctcucvcwcxcyczQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"];

our $image5;
our $image5_data =
["22 22 277 2",
"Qt c #750000",
"ce c #770101",
".# c #7a0303",
"cr c #850707",
"cs c #870808",
"b5 c #880909",
"bX c #8b0b0b",
"bP c #8d0c0c",
"bC c #8f0e0e",
"bo c #900f0f",
"be c #921010",
"a3 c #941111",
"aT c #951212",
"aG c #961313",
"av c #981414",
"af c #991515",
"#2 c #9a1616",
"#M c #9b1616",
".t c #9b1717",
".a c #9c1717",
"#e c #9e1818",
".3 c #9e1919",
".L c #9f1919",
".b c #a01a1a",
"ax c #a43e3e",
"cf c #ab1919",
"#Q c #ab7575",
"aJ c #ad4141",
"aj c #ad6666",
"#A c #af7d7d",
"#O c #b41e1e",
"bk c #b43f3f",
"#3 c #b72121",
"aW c #b76b6b",
"#w c #b93737",
"#6 c #b94646",
"aA c #ba7474",
"ao c #ba7a7a",
"ah c #bb2424",
"#m c #bb7979",
"aS c #bc4444",
"aN c #bc7373",
"a. c #bc7575",
"bM c #bd4747",
"a9 c #bd7272",
"bm c #be7171",
"aZ c #be7474",
"#l c #be9090",
"cg c #c12828",
"b2 c #c17070",
"aw c #c23232",
"bT c #c24949",
"b6 c #c32828",
"aF c #c34545",
"bf c #c36969",
"#B c #c56363",
"aI c #c63535",
"aU c #c72b2b",
".v c #c96565",
"#n c #c98080",
"#N c #ca2e2e",
"#v c #cb2f2f",
"#x c #cb6363",
"#g c #cb6c6c",
"ag c #cc2f2f",
"aH c #cc3030",
"ak c #cc3838",
"a1 c #cc4040",
"#0 c #cc8a8a",
"#f c #cd3030",
".4 c #cd3131",
"#o c #cd9999",
"a4 c #ce3030",
"ch c #ce3131",
".M c #ce3232",
"#h c #ce7474",
"cd c #cf3131",
"b9 c #cf4949",
"#R c #cf5b5b",
"#5 c #cfb2b2",
".f c #d03232",
".e c #d03333",
"#P c #d06e6e",
"ci c #d13333",
"bu c #d13d3d",
"al c #d14444",
".5 c #d17b7b",
".g c #d23333",
"cj c #d23434",
"au c #d23f3f",
"aK c #d33434",
"a7 c #d33636",
"ay c #d33737",
"#7 c #d35252",
"a6 c #d3aeae",
"#k c #d3bebe",
"bp c #d43434",
".h c #d43535",
"am c #d44646",
"bs c #d46f6f",
"#i c #d47e7e",
".6 c #d48484",
"ck c #d53636",
"#8 c #d55353",
".i c #d63636",
"aL c #d63737",
"#S c #d66060",
".N c #d68989",
"bD c #d73737",
"cl c #d83838",
"bz c #d84444",
"#W c #d86464",
"#r c #d88585",
".7 c #d88d8d",
".j c #d93838",
"#T c #d96363",
".O c #d99494",
"bS c #d9b3b3",
"aX c #da3939",
"b8 c #da4d4d",
"#C c #da6f6f",
"ad c #dabebe",
".k c #db3939",
"cm c #db3a3a",
".P c #db9595",
".w c #db9898",
"by c #dbb5b5",
"#J c #dbc1c1",
"cn c #dc3b3b",
"c. c #dc4545",
"bE c #dc4646",
"#D c #dc7070",
"bY c #dc7777",
".x c #dc9999",
"b1 c #dcb8b8",
"bb c #dcb9b9",
".l c #dd3b3b",
"co c #dd3c3c",
"bQ c #dd4848",
"cp c #de3c3c",
"#E c #de7272",
"#H c #de9797",
".y c #de9a9a",
".W c #deafaf",
"bZ c #deb9b9",
".m c #df3c3c",
"cq c #df3d3d",
"#p c #dfc6c6",
"bg c #e03d3d",
"#F c #e07373",
".z c #e09b9b",
"#. c #e0c9c9",
".n c #e13e3e",
"#V c #e1b2b2",
"bG c #e1b4b4",
".u c #e23f3f",
"aB c #e24444",
"bc c #e24747",
"ap c #e25050",
"a# c #e25c5c",
"#X c #e26969",
"#G c #e27575",
"#9 c #e28383",
"bR c #e2b5b5",
".o c #e33f3f",
"b7 c #e34040",
"## c #e39595",
".A c #e3a2a2",
".d c #e44040",
"b4 c #e44141",
"bh c #e44b4b",
"aq c #e45151",
"ae c #e45757",
"aa c #e45e5e",
"#Y c #e46a6a",
"az c #e47f7f",
"an c #e48686",
".B c #e4a3a3",
".p c #e54040",
"bt c #e54242",
".C c #e59f9f",
"#4 c #e5b5b5",
"bW c #e64141",
"aO c #e64242",
"aC c #e64747",
"aM c #e67d7d",
".q c #e74242",
"bO c #e74343",
"ab c #e76060",
".J c #e77a7a",
".D c #e7a0a0",
"bq c #e7b5b5",
".Q c #e7b6b6",
"aP c #e84343",
"aD c #e84646",
"ar c #e85454",
"#K c #e87979",
"aY c #e87e7e",
"#Z c #e89494",
".E c #e8a1a1",
"a5 c #e8b8b8",
".V c #e8d4d4",
"bB c #e94343",
"bv c #e94444",
".F c #e9a2a2",
"aQ c #ea4545",
"a8 c #ea7c7c",
".X c #ea9f9f",
"bd c #eb4545",
".Y c #eba0a0",
".G c #eba3a3",
"#U c #ebb6b6",
"#y c #ebc8c8",
"a2 c #ec4545",
".2 c #ec4646",
"bH c #ec5d5d",
"aE c #ec5e5e",
"#a c #ec9494",
".H c #eca4a4",
"b. c #ed4646",
"#d c #ed4747",
".c c #ed4949",
"#s c #ed8989",
"#b c #ed9696",
".Z c #eda1a1",
".I c #eda5a5",
"ac c #edc1c1",
".R c #edd7d7",
"#u c #ee4747",
".s c #ee4a4a",
"aR c #ee5d5d",
"#1 c #ee6e6e",
"#L c #ee7878",
"#t c #ee8484",
"#c c #ee8f8f",
".1 c #ee9a9a",
".0 c #eea2a2",
".8 c #eed2d2",
"bj c #eedfdf",
"b# c #ef4848",
"bI c #ef5d5d",
"as c #f08d8d",
"b0 c #f0e1e1",
"at c #f0e2e2",
"c# c #f14b4b",
".r c #f24a4a",
".K c #f24b4b",
"aV c #f2e1e1",
"#q c #f2ebeb",
"ai c #f3e0e0",
"bi c #f3e1e1",
"bL c #f3e6e6",
".U c #f3ebeb",
"a0 c #f48484",
"bJ c #f48585",
"bF c #f4e6e6",
".S c #f4ecec",
"bU c #f54e4e",
"bl c #f57d7d",
"bw c #f57f7f",
"bK c #f5bebe",
"br c #f5eded",
"#z c #f5f0f0",
"bn c #f64e4e",
"#j c #f7eded",
"#I c #f7f1f1",
"ba c #f8bcbc",
"ca c #f94f4f",
"bA c #fa5050",
"bN c #fb5151",
"bx c #fbf0f0",
"bV c #fc5252",
"b3 c #fd5353",
"cb c #fe5353",
".T c #fefefe",
"cc c #ff5454",
".9 c #ffffff",
"Qt.#.a.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.a.#Qt",
".#.c.d.e.f.f.f.f.g.h.i.j.k.l.m.n.o.p.q.r.s.#",
".t.u.v.w.w.w.w.x.y.z.A.B.C.D.E.F.G.H.I.J.K.t",
".L.M.N.O.O.O.P.Q.R.S.T.T.U.V.W.X.Y.Z.0.1.2.L",
".3.4.5.6.6.7.8.9.9.9.9.9.9.9.9#.###a#b#c#d.3",
"#e#f#g#h#i#j.9.9#k#l#m#n#o#p.9.9#q#r#s#t#u#e",
".a#v#w#x#y.9#z#A#B#C#D#E#F#G#H#I.9#J#K#L#d.a",
"#M#N#O#P.9.9#Q#R#S#T#U#V#W#X#Y#Z.9.9#0#1#u#M",
"#2#N#3#4.9#5#6#7#8#9.9.9a.a#aaabac.9adae#d#2",
"afagahai.9ajakalaman.9.9aoapaqaras.9atau#uaf",
"av#vaw.T.9ax#f.fayaz.9.9aAaBaCaDaE.9.TaF#dav",
"aGaHaI.T.9aJ.faKaLaM.9.9aNaOaPaQaR.9.TaS#daG",
"aTagaUaV.9aWaKaLaXaY.9.9aZaPaQ.2a0.9ata1a2aT",
"a3a4#Na5.9a6a7aX.la8.9.9a9aQb.b#ba.9bbbcbda3",
"be#f#f#D.9.9bf.lbgbhbibjbkb.b#bl.9.9bmbnaQbe",
"bo#f.fbpbq.9brbs.oaObtbubvb#bwbx.9bybzbAbBbo",
"bCa4bpbDbEbF.9.9bGaYbHbIbJbK.9.9bLbMbAbNbObC",
"bP#fbDaX.lbQbR.9.9.9.9.9.9.9.9bSbTbUbNbVbWbP",
"bXaHaX.lbg.oaObYbZb0.T.Tb0b1b2bEbAbNbVb3b4bX",
"b5b6.lbgb7aOaPaQb.aDb8b9c.c#cabAbNbVcbcccdb5",
"cecfcgch.fcicj.hckbDclaX.kcmcn.lcocpcq#vcfce",
"QtcecrcscscscscscscscscscscscscscscscscrceQt"];


sub NEW
{
    shift->SUPER::NEW(@_[0..2]);

    $image0 = Qt::Pixmap($image0_data);
    $image1 = Qt::Pixmap($image1_data);
    $image2 = Qt::Pixmap($image2_data);
    $image3 = Qt::Pixmap($image3_data);
    $image4 = Qt::Pixmap($image4_data);
    $image5 = Qt::Pixmap($image5_data);

    if ( name() eq "unnamed" )
    {
        setName("LocalEditorWidget" );
    }
    setIcon($image0 );

    my $LocalEditorWidgetLayout = Qt::GridLayout(this, 1, 1, 11, 6, '$LocalEditorWidgetLayout');

    lv_messages = Qt::ListView(this, "lv_messages");
    lv_messages->addColumn(trUtf8("Code/Index"));
    lv_messages->addColumn(trUtf8("Message"));
    lv_messages->setAllColumnsShowFocus( 1 );
    lv_messages->setShowSortIndicator( 1 );

    $LocalEditorWidgetLayout->addWidget(lv_messages, 1, 0);

    commandButtonGroup = Qt::ButtonGroup(this, "commandButtonGroup");
    commandButtonGroup->setColumnLayout( 0, &Vertical );
    commandButtonGroup->layout()->setSpacing(6);
    commandButtonGroup->layout()->setMargin(11);
    my $commandButtonGroupLayout = Qt::GridLayout(commandButtonGroup->layout() );
    $commandButtonGroupLayout->setAlignment( &AlignTop );

    addMessageButton = Qt::PushButton(commandButtonGroup, "addMessageButton");
    addMessageButton->setIconSet( Qt::IconSet($image1) );

    $commandButtonGroupLayout->addWidget(addMessageButton, 0, 0);

    removeMessageButton = Qt::PushButton(commandButtonGroup, "removeMessageButton");
    removeMessageButton->setIconSet( Qt::IconSet($image2) );

    $commandButtonGroupLayout->addWidget(removeMessageButton, 0, 1);

    saveButton = Qt::PushButton(commandButtonGroup, "saveButton");
    saveButton->setIconSet( Qt::IconSet($image3) );

    $commandButtonGroupLayout->addWidget(saveButton, 0, 2);

    openButton = Qt::PushButton(commandButtonGroup, "openButton");
    openButton->setIconSet( Qt::IconSet($image4) );

    $commandButtonGroupLayout->addWidget(openButton, 0, 3);

    closeButton = Qt::PushButton(commandButtonGroup, "closeButton");
    closeButton->setIconSet( Qt::IconSet($image5) );

    $commandButtonGroupLayout->addWidget(closeButton, 0, 4);

    $LocalEditorWidgetLayout->addWidget(commandButtonGroup, 0, 0);
    languageChange();
    my $resize = Qt::Size(645, 480);
    $resize = $resize->expandedTo(minimumSizeHint());
    resize( $resize );
    clearWState( &Qt::WState_Polished );

    Qt::Object::connect(closeButton, SIGNAL "clicked()", this, SLOT "close()");
    Qt::Object::connect(openButton, SIGNAL "clicked()", this, SLOT "openButton_clicked()");
    Qt::Object::connect(removeMessageButton, SIGNAL "clicked()", this, SLOT "removeMessageButton_clicked()");
    Qt::Object::connect(addMessageButton, SIGNAL "clicked()", this, SLOT "addMessageButton_clicked()");
    Qt::Object::connect(saveButton, SIGNAL "clicked()", this, SLOT "saveButton_clicked()");
    Qt::Object::connect(lv_messages, SIGNAL "doubleClicked(QListViewItem*)", this, SLOT "lv_messages_doubleClicked(QListViewItem*)");

    init();
}


sub DESTROY
{
    destroy();
    SUPER->DESTROY()
}


sub languageChange
{
    setCaption(trUtf8("Locales editor for slack-get") );
    lv_messages->header()->setLabel( 0, trUtf8("Code/Index") );
    lv_messages->header()->setLabel( 1, trUtf8("Message") );
    commandButtonGroup->setTitle( undef );
    addMessageButton->setText( trUtf8("Add message") );
    addMessageButton->setAccel( Qt::KeySequence( trUtf8("Ctrl+A") ) );
    removeMessageButton->setText( trUtf8("Remove message") );
    removeMessageButton->setAccel( Qt::KeySequence( trUtf8("Del") ) );
    saveButton->setText( trUtf8("Save") );
    saveButton->setAccel( Qt::KeySequence( trUtf8("Ctrl+S") ) );
    openButton->setText( trUtf8("Open") );
    closeButton->setText( trUtf8("Close") );
}


my $file;
my $local;
my $is_modified;
my $VERSION='0.1';

sub init
{
    setCaption(trUtf8("Locales editor for slack-get - version $VERSION") );
    $local = slackget10::Local->new();
}


sub destroy
{
    if($is_modified)
    {
	my $resp = Qt::MessageBox::warning ( this, 'Save modifications', "Do you want to save the last changes ?",&Qt::MessageBox::Yes, &Qt::MessageBox::No, &Qt::MessageBox::NoButton );
	if($resp == &Qt::MessageBox::Yes) 
	{
	    saveButton_clicked();
	}
    }
}


sub openButton_clicked
{
    $file = Qt::FileDialog::getOpenFileName("$ENV{PWD}","XML files (*.xml)",this,"open file dialog", "Choose a \"Local\" file to open" );
    loadLocalFile($file);
}


sub removeMessageButton_clicked
{
    my $item = lv_messages->selectedItem();
    lv_messages->takeItem($item) if(defined($item) && $item);
    $is_modified=1;
}


sub addMessageButton_clicked
{
     my $name = Qt::InputDialog::getText("slack-get Locales editor", "Please give an index name for the new message :");
    my $value = Qt::InputDialog::getText("slack-get Locales editor", "You can now type your message (you can use the Qt rich text format which support basic HTML like &lt;br&gt;, &lt;u&gt;, &lt;b&gt; tags) :");
     if($name !~ /^$/ && $value !~ /^$/)
     {
	createItem(lv_messages,$name,$value);
	$is_modified=1;
     }
}


sub loadLocalFile # SLOT: ( const QString & )
{
    my $filename = shift;
    if(defined($filename) && $filename)
    {
	if( -e $filename )
	{
	    if($local->Load($filename))
	    {
		&fillListViewFromLocalObject;
	    }
	    else
	    {
		Qt::MessageBox::critical(this,'Error',"An error occured while loading local from \"$filename\".<br>Maybe the XML file is not well formed.",&Qt::MessageBox::Ok, &Qt::MessageBox::NoButton, &Qt::MessageBox::NoButton);
	    }
	}
	else
	{
	    Qt::MessageBox::critical(this,'File not found',"the file : \"$filename\" was not found.<br>System say :<br>$!",&Qt::MessageBox::Ok, &Qt::MessageBox::NoButton, &Qt::MessageBox::NoButton);
	}
    }
}


sub fillListViewFromLocalObject
{
    lv_messages->clear();
    foreach ( $local->get_indexes )
    {
        createItem(lv_messages, $_, $local->Get($_));
    }
}


sub createItem # SLOT: ( QListView *, const QString &, const QString & )
{
    my ($lv,$idx,$txt) = @_ ;
    my $item = Qt::ListViewItem( $lv );
    $item->setText(0,$idx);
    $item->setText(1,$txt);
}


sub saveButton_clicked
{
     $file = Qt::FileDialog::getSaveFileName("$file","XML files (*.xml)",this,"save file dialog","Choose a filename to save the \"Local\" under" );
     my $ok=0;
     my $name = Qt::InputDialog::getText("Locales editor", "Enter a name for this langpack (users will see this name) :", &Qt::LineEdit::Normal,$local->name, $ok, this );
    $local->name($name) if($ok);
     our $xml = "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"yes\"?>\n<local name=\"".$local->name."\">\n";
     my $item = lv_messages->firstChild();
    $xml .= "\t<message id=\"".$item->text(0)."\"><![CDATA[".$item->text(1)."]]></message>\n";
     while($item = $item->nextSibling())
     {
          $xml .= "\t<message id=\"".$item->text(0)."\"><![CDATA[".$item->text(1)."]]></message>\n";
     }
     $xml .= "\n</local>\n";
     my $file = slackget10::File->new($file, 'no-auto-load'=>1);
     $file->Add($xml);
     $file->Write_and_close  ;
     $is_modified = 0;
     emit(localSaved);
}


sub lv_messages_doubleClicked # SLOT: ( QListViewItem * )
{
    my $item = shift;
    my $ok=0;
    my $value = Qt::InputDialog::getText("slack-get Locales editor", "You can now type your message for the message indexed as <font color='blue'><b>\"".$item->text(0)."\"</b></font> <br>(you can use the Qt rich text format which support basic HTML like &lt;br&gt;, &lt;u&gt;, &lt;b&gt; tags) :", &Qt::LineEdit::Normal,$item->text(1),$ok,this);
    $item->setText(1,$value) if($ok) ;
    $is_modified=1;
}


sub about_editor
{
    Qt::MessageBox::about( this, "About Langpack Editor", "This slack-get plug-in allow every user to edit or create slack-get's langpack.\n\nId: LocalEditor\nCoder: Arnaud DUPUIS <a.dupuis\@infinityperl.org\nVersion: $VERSION\nplug-in type: GUI\nLicense: GNU/GPL v2\n\nThis program come without any warranty. Use it at your own risks.\n");
}

1;
